/*
	Copyright 2008 Xavier Dunat

    This file is part of Suisse.

    Suisse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Suisse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suisse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdarg.h>
#include <stdio.h>
#include <string.h>
#include "log.h"
#include "joueur.h"

/**
 * \file log.c
 * \author Xavier Dunat
 * \brief système de LOG
 */

FILE *fileLog;
char *functionName;
int initlog(int levelView, const char *fileName)
{
	strcpy(nameFileLog, fileName);
	logLevelView=levelView;
}
int myLog(const char *text, ...)
{
	va_list args ;
	va_start(args, text);
	if (logLevel<=logLevelView) {
		if ((fileLog=fopen(nameFileLog,"a"))!=NULL)
		{
			fprintf(fileLog, "%15s: " ,functionName);
			vfprintf(fileLog, text, args);
			fprintf(fileLog,"\n");
			fclose(fileLog);
		}
	}
	return(OK);
}

int logList(const char *text, struct listOfPlayer list)
{
	int i;
	if ((fileLog=fopen(nameFileLog,"a"))!=NULL)
	{
		fprintf(fileLog, "%s\n" ,text);
		for (i=0;i<list.nbPlayer;i++)
			fprintf(fileLog,"%d\n", list.Player[i].numPairing);
		fclose(fileLog);
	}
	return(OK);
}
