/*
	Copyright 2003 Xavier Dunat

    This file is part of Suisse.

    Suisse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Suisse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suisse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <string.h>
#include <stdlib.h>
#include "joueur.h"
#include "iosuisse.h"
#include "pass.h"
#include "log.h"

/**
 * \file pass.c
 * \author Xavier Dunat
 * \brief GUI du programme PASS
 */

GtkWidget *viewPairing;
GtkWidget *viewPlayer;
void affichagePairing(GtkWidget *widget, gpointer data)
{
	gtk_widget_show( viewPairing);
	gtk_widget_hide(viewPlayer);
}
void affichagePlayer(GtkWidget *widget, gpointer data)
{
	insertPlayerInList();
	gtk_widget_show(viewPlayer);
	gtk_widget_hide(viewPairing);
}
void newTournament(GtkWidget *widget, gpointer data)
{
	GtkWidget *labelName,*labelDateBegin, *labelDateEnd, *labelNumberRound;
	GtkWidget *labelArbiterName, *labelArbiterTitle;
	GtkWidget *entryName,*entryDateBegin, *entryDateEnd, *entryNumberRound;
	GtkWidget *entryArbiterName, *entryArbiterTitle;
	GtkWidget *window;
	GtkWidget *VBox, *roundBox, *titleBox, *buttonBox;
	
	window=gtk_dialog_new_with_buttons("Saisie du tournoi",
		GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_STOCK_OK,GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);
	labelName=gtk_label_new("Nom du tournoi");
	labelDateBegin=gtk_label_new("Date de la première ronde");
	labelDateEnd=gtk_label_new("Date de la dernière ronde");
	labelNumberRound=gtk_label_new("Nombre de ronde");
	labelArbiterName=gtk_label_new("Nom de l'arbitre principal");
	labelArbiterTitle=gtk_label_new("Titre de l'arbitre");
	entryName=gtk_entry_new();
	entryDateBegin=gtk_entry_new();
	entryDateEnd=gtk_entry_new();
	entryNumberRound=gtk_entry_new();
	entryArbiterName=gtk_entry_new();
	entryArbiterTitle=gtk_entry_new();
	VBox=gtk_vbox_new(TRUE, 0);
	//gtk_container_add(GTK_CONTAINER(window), VBox);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			labelName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			entryName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			labelDateBegin, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			entryDateBegin, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			labelDateEnd, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			entryDateEnd, TRUE, FALSE, 0);
	roundBox=gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(roundBox), labelNumberRound, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(roundBox), entryNumberRound, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
				roundBox, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			labelArbiterName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			entryArbiterName, TRUE, FALSE, 0);
	g_nbRound=atoi(gtk_entry_get_text(GTK_ENTRY(entryNumberRound)));
	buttonBox=gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox),
			buttonBox, TRUE, FALSE, 0);
	gtk_widget_show_all(GTK_DIALOG(window)->vbox);
	switch(gtk_dialog_run(GTK_DIALOG(window)))
	{
		case GTK_RESPONSE_OK :
			newMatch=TRUE;
			int i, j;
			g_nbRound=atoi(gtk_entry_get_text(GTK_ENTRY(entryNumberRound)));
			resultValidate=malloc((g_nbRound+1)*sizeof(gboolean));
			roundAlreadyPaired=malloc((g_nbRound+1)
							*sizeof(gboolean));
			g_listTable  =malloc((g_nbRound+1)*sizeof(struct table*));
			g_nbPlayerOut=malloc((g_nbRound+1)*sizeof(int));
			g_nbTable    =malloc((g_nbRound+1)*sizeof(int));
			STD_LOG("newTournament")("nb ronde=%d", g_nbRound);
			for (i=0;i<=g_nbRound;i++)
			{
				resultValidate[i]=FALSE;
				roundAlreadyPaired[i]=FALSE;
				g_nbPlayerOut[i]=0;
				g_nbTable[i]=0;
			}
			g_round=1;
			g_nbRoundValidated=0;
			g_nbNotPaired=0;
			g_listPlayer.nbPlayer=0;
			g_listPlayer.Player=malloc(sizeof(struct player));
			listPlayerDisplay=malloc(sizeof(struct player));
			DET_LOG("newTournament")("Created");
		case GTK_RESPONSE_CANCEL :
		case GTK_RESPONSE_NONE:
		default :
			break;
	}
	gtk_widget_destroy(window);
}
void insertPlayerInList() {
	GtkTreeIter iter;
	int i;
	copyStructPlayer(g_listPlayer.Player, listPlayerDisplay, g_listPlayer.nbPlayer);
	STD_LOG("insertPlayerInList")("copyStructPlayer OK");
	classement(listPlayerDisplay);
	
	gtk_list_store_clear(listPlayer);
	for (i=0; i<g_listPlayer.nbPlayer; i++)
	{	
		gtk_list_store_append(listPlayer, &iter);
		gtk_list_store_set(listPlayer, &iter,
			P_NUM_APP_COLUMN, listPlayerDisplay[i].numPairing,
			P_SURNAME_COLUMN, listPlayerDisplay[i].surname,
			P_NAME_COLUMN, listPlayerDisplay[i].name,
			P_ELO_COLUMN, listPlayerDisplay[i].elo,
			P_RESULT_COLUMN, listPlayerDisplay[i].score, -1);
	}
	STD_LOG("insertPlayerInList")("return");
}	
void openFilePlayerOK(GtkWidget *widget, GtkFileSelection *fs)
{
	int i,j;
	readPlayer((char*)gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
	for (i=0; i<g_nbRound; i++) {
		g_listTable[i]=malloc((g_listPlayer.nbPlayer+1)*sizeof(struct table));
		for (j=0; j<g_nbTable[g_nbRound]; j++) {
			strcpy(g_listTable[i][j].result, "XXX-XXX");
		}
	}
	gtk_list_store_clear(listPlayer);
	gtk_widget_destroy((GtkWidget*)fs);
	numPairing(g_listPlayer);
	
	insertPlayerInList();
}
void openFilePlayer(GtkWidget *widget, gpointer data)
{
	if (newMatch)
	{
		GtkWidget *window;
		window=gtk_file_selection_new("Ouvrir une liste de joueur");
		g_signal_connect(
				G_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
				"clicked", G_CALLBACK(openFilePlayerOK), window);
		gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(window)
					     ->cancel_button), "clicked",
					   G_CALLBACK(gtk_widget_destroy),
					   G_OBJECT (window));
		gtk_widget_show(window);
	}
	else
	{
		GtkWidget *dialog;
		dialog=gtk_message_dialog_new(
			GTK_WINDOW(pwindow),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_ERROR,
			GTK_BUTTONS_OK,
			"Vous devez d'abord créer le tournoi",
			NULL);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
}
void writeTournament(GtkWidget *widget, GtkFileSelection *fs)
{
	if(writeFileTournament(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)))!=OK) {
		GtkWidget *dialog;
		dialog=gtk_message_dialog_new(
			GTK_WINDOW(pwindow),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_ERROR,
			GTK_BUTTONS_OK,
			"Impossible d'enregistrer le fichier",
			NULL);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
	gtk_widget_destroy((GtkWidget*)fs);
}
void saveTournament(GtkWidget *widget, gpointer data)
{
	if (newMatch)
	{
		GtkWidget *window;
		window=gtk_file_selection_new("Enregistrer un tournoi");
		g_signal_connect(
				G_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
				"clicked", G_CALLBACK(writeTournament), window);
		gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(window)
					     ->cancel_button), "clicked",
					   G_CALLBACK(gtk_widget_destroy),
					   G_OBJECT (window));
		gtk_widget_show(window);
	}
	else
	{
		GtkWidget *dialog;
		dialog=gtk_message_dialog_new(
			GTK_WINDOW(pwindow),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_ERROR,
			GTK_BUTTONS_OK,
			"Vous devez d'abord créer le tournoi",
			NULL);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
	}
}

void openTournament(GtkWidget *widget, GtkFileSelection *fs)
{
	DET_LOG("openTournament")("entering");
	int i, j;
	if (readFileTournament(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)))==OK) {
		newMatch=TRUE;
		resultValidate=malloc((g_nbRound+1)*sizeof(gboolean));
		roundAlreadyPaired=malloc((g_nbRound+1)*sizeof(gboolean));
		for (i=0;i<=g_nbRound;i++)
		{
			resultValidate[i]=FALSE;
			roundAlreadyPaired[i]=FALSE;
		}
	}
	gtk_widget_destroy((GtkWidget*)fs);
	DET_LOG("openTournament")("return OK");
}

void readTournament(GtkWidget *widget, gpointer data)
{
		GtkWidget *window;
		window=gtk_file_selection_new("Ouvrir un tournoi");
		g_signal_connect(
				G_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
				"clicked", G_CALLBACK(openTournament), window);
		gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(window)
					     ->cancel_button), "clicked",
					   G_CALLBACK(gtk_widget_destroy),
					   G_OBJECT (window));
		gtk_widget_show(window);
}

void calculPairing(GtkWidget *widget, gpointer data)
{
	int i;
	gboolean canApparied=TRUE;
	GtkWidget *window, *labelRound, *entryRound, *HBox;
	GtkTreeIter iter;
	labelRound=gtk_label_new("Numéro de ronde");
	entryRound=gtk_entry_new();
	HBox=gtk_hbox_new(TRUE, 0);
	window=gtk_dialog_new_with_buttons("Appariement",
				GTK_WINDOW(pwindow),
				GTK_DIALOG_MODAL,
				GTK_STOCK_OK,GTK_RESPONSE_OK,
				GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
				NULL);
	gtk_box_pack_start(GTK_BOX(HBox), labelRound, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(HBox), entryRound, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), HBox, TRUE, FALSE, 0);
	gtk_widget_show_all(window);
	
	switch(gtk_dialog_run(GTK_DIALOG(window)))
	{
		case GTK_RESPONSE_OK :
		{
			int roundChoice;
			roundChoice = atoi(gtk_entry_get_text(GTK_ENTRY(entryRound)));
			DET_LOG("calculPairing")("appariement ronde %d", roundChoice);
			if (roundChoice>1)
				for (i=0; i<g_listPlayer.nbPlayer; i++)
					if (g_listPlayer.Player[i].resultat[roundChoice-1]==NO_SCORE && g_listPlayer.Player[i].out[roundChoice-1]==0) {
						STD_LOG("calculPairing")("joueur %d non saisie", g_listPlayer.Player[i].numPairing);
						canApparied=FALSE;
					}
			if (canApparied==TRUE)
			{
				g_round=roundChoice;
				if (!roundAlreadyPaired[roundChoice])
				{
					appariement();
					if (g_round>g_nbRoundValidated)
						g_nbRoundValidated=g_round;
					matchGet=malloc(g_nbTable[g_round]*sizeof(gboolean));
					nbRoundPaired=g_round;
					roundAlreadyPaired[g_round]=TRUE;
					for (i=0;i<g_nbTable[g_round];i++)
						matchGet[i]=FALSE;
				}
				gtk_list_store_clear(listTable);
				for (i=0; i<g_nbTable[g_round]; i++)
				{	
					gtk_list_store_append(listTable,&iter);
					gtk_list_store_set(listTable, &iter,
						NUM_TABLE_COLUMN, i+1,
						NUM_APP_PLAYER_COLUMN,
						g_listTable[roundChoice-1][i].white.numPairing,
						PLAYER_COLUMN,
						g_listTable[roundChoice-1][i].white.surname,
						RESULT_COLUMN,
						g_listTable[roundChoice-1][i].result,
						NUM_APP_ADV_COLUMN,
						g_listTable[roundChoice-1][i].black.numPairing,
						ADV_COLUMN,
						g_listTable[roundChoice-1][i].black.surname,
						-1);
				}
			}
			else
			{
				GtkWidget *dialog;
				dialog=gtk_message_dialog_new(
					GTK_WINDOW(pwindow),
					GTK_DIALOG_MODAL,
					GTK_MESSAGE_ERROR,
					GTK_BUTTONS_OK,
					"appariement impossible",
					NULL);
				gtk_dialog_run(GTK_DIALOG(dialog));
				gtk_widget_destroy(dialog);
			}
			insertPlayerInList();
			break;
		}
		case GTK_RESPONSE_CANCEL :
		case GTK_RESPONSE_NONE:
		default :
			break;
	}
	gtk_widget_destroy(window);
	
}
void modifierPairing(GtkWidget *widget, gpointer data)
{
	g_print ("ModifierPairing appele\n");
}
void addPlayer(GtkWidget *widget, gpointer data)
{
	GtkWidget* labelName, *labelSurname, *labelTitle, *labelElo;
	GtkWidget* entryName, *entrySurname, *entryTitle, *entryElo;
	GtkWidget *dialog, *boxSurname, *boxName, *boxTitle, *boxElo;
	char surname[10], name[10];
	int elo, title, i, j;
	GtkCellRenderer   * p_cell  = NULL;
	GtkListStore      *p_model  = NULL;
	GtkTreeIter iter;
	combo_data_st     p_st;

	p_model = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);

	if (!newMatch) {
		GtkWidget *dialog;
		dialog=gtk_message_dialog_new(
			GTK_WINDOW(pwindow),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_ERROR,
			GTK_BUTTONS_OK,
			"Vous devez d'abord créer le tournoi",
			NULL);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		return;
	}
	if (g_nbRoundValidated>0)
	{
		GtkWidget *dialog;
		dialog=gtk_message_dialog_new(
			GTK_WINDOW(pwindow),
			GTK_DIALOG_MODAL,
			GTK_MESSAGE_ERROR,
			GTK_BUTTONS_OK,
			"Impossible d'ajouter un joueur après avoir apparié une ronde",
			NULL);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		return;

	}
	dialog=gtk_dialog_new_with_buttons("saisie joueur",
		                          GTK_WINDOW(pwindow),
		                          GTK_DIALOG_MODAL,
		                          GTK_STOCK_OK, GTK_RESPONSE_OK,
		                          GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		 			  NULL);
	boxSurname=gtk_hbox_new(TRUE, 0);
	boxName=gtk_hbox_new(TRUE, 0);
	boxTitle=gtk_hbox_new(TRUE, 0);
	boxElo=gtk_hbox_new(TRUE, 0);
	
	labelTitle=gtk_label_new("Titre");
	entryTitle= gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model));

	/* définition de l'affichage */
	p_cell = gtk_cell_renderer_text_new ();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (entryTitle), p_cell, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (entryTitle), p_cell, "text", 0, NULL);

	p_cell = gtk_cell_renderer_text_new ();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (entryTitle), p_cell, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (entryTitle), p_cell, "text", 1, NULL );

	/* déclaration de la liste */
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 0, 1, "Pas de titre", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 1, 1, "CF", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 2, 1, "MFideF", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 3, 1, "MFide", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 4, 1, "MIF", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 5, 1, "MI", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 6, 1, "GMIF", -1);
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, 7, 1, "GMI", -1);

	labelName=gtk_label_new("Prénom");
	entryName=gtk_entry_new();
	labelSurname=gtk_label_new("Nom");
	entrySurname=gtk_entry_new();
	labelElo=gtk_label_new("Elo");
	entryElo=gtk_entry_new();
	
	gtk_box_pack_start(GTK_BOX(boxSurname), labelSurname, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxSurname), entrySurname, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxName), labelName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxName), entryName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxTitle), labelTitle, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxTitle), entryTitle, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxElo), labelElo, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(boxElo), entryElo, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), boxSurname, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), boxName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), boxTitle, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), boxElo, TRUE, FALSE, 0);

	/* Valeur par défaut */
	gtk_combo_box_set_active (GTK_COMBO_BOX (entryTitle), 0);
	
	gtk_widget_show_all(dialog);	
        switch(gtk_dialog_run(GTK_DIALOG(dialog)))
	{
		case GTK_RESPONSE_OK :
			strcpy(surname, gtk_entry_get_text(GTK_ENTRY(entrySurname)));
			strcpy(name, gtk_entry_get_text(GTK_ENTRY(entryName)));
			elo=atoi(gtk_entry_get_text(GTK_ENTRY(entryElo)));
			if (gtk_combo_box_get_active_iter(GTK_COMBO_BOX(entryTitle), &iter)) {
				gtk_tree_model_get (p_model, & iter,
					0, & p_st.index,
					1, & p_st.p_text, -1);
 				title=p_st.index;
				setPlayerWithParam(surname, name, elo, title);
				numPairing(g_listPlayer);
				insertPlayerInList();
				
				
				for (i=0; i<g_nbRound; i++) {
					g_listTable[i]=malloc((g_listPlayer.nbPlayer+1)*sizeof(struct table));
					for (j=0; j<g_listPlayer.nbPlayer/2; j++) {
						strcpy(g_listTable[i][j].result,"XXX-XXX");
					}
				}

			} else {
				GtkWidget *dialog;
				dialog=gtk_message_dialog_new(
					GTK_WINDOW(pwindow),
					GTK_DIALOG_MODAL,
					GTK_MESSAGE_ERROR,
					GTK_BUTTONS_OK,
					"Saissiez le titre",
					NULL);
				gtk_dialog_run(GTK_DIALOG(dialog));
				gtk_widget_destroy(dialog);
			}
			break;
		case GTK_RESPONSE_CANCEL :
		case GTK_RESPONSE_NONE:
		default :
		        break;
	}
	gtk_widget_destroy(dialog);
}
void supPlayer(GtkWidget *widget, gpointer data)
{
	GtkWidget *window, *entryName, *labelName, *entryRound, *labelRound;
	int numPlayer;
	window=gtk_dialog_new_with_buttons("Suppression d'un joueur",
		GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_STOCK_OK,GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);
	labelName=gtk_label_new("Numéro d'appariement");
	labelRound=gtk_label_new("à partir de la ronde :");
	entryName=gtk_entry_new();
	entryRound=gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelName,
			   TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryName,
			   TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelRound,
			   TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryRound,
			   TRUE, FALSE, 0);
	gtk_widget_show_all(window);
        switch(gtk_dialog_run(GTK_DIALOG(window)))
	{
		case GTK_RESPONSE_OK :
			numPlayer=atoi(
				gtk_entry_get_text(GTK_ENTRY(entryName)));
			int round=
				atoi(gtk_entry_get_text(GTK_ENTRY(entryRound)));
			getOutOnePlayer(numPlayer, 
				atoi(gtk_entry_get_text(GTK_ENTRY(entryRound))),
				g_nbRound);
		case GTK_RESPONSE_NONE :
		case GTK_RESPONSE_CANCEL :
		default :
			break;
	}
	gtk_widget_destroy(window);
}

void forfaitPlayer(GtkWidget *widget, gpointer data)
{
	GtkWidget *window, *entryName, *labelName, *entryRound, *labelRound;
	int numPlayer;
	window=gtk_dialog_new_with_buttons("Retrait d'un joueur",
		GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_STOCK_OK,GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);
	labelName=gtk_label_new("Numéro d'appariement");
	labelRound=gtk_label_new("forfait à la ronde :");
	entryName=gtk_entry_new();
	entryRound=gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryName, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelRound, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryRound, TRUE, FALSE, 0);
	gtk_widget_show_all(window);
        switch(gtk_dialog_run(GTK_DIALOG(window)))
	{
		case GTK_RESPONSE_OK :
			numPlayer=atoi(
				gtk_entry_get_text(GTK_ENTRY(entryName)));
			int round=
				atoi(gtk_entry_get_text(GTK_ENTRY(entryRound)));
			getOutOnePlayer(numPlayer, 
				atoi(gtk_entry_get_text(GTK_ENTRY(entryRound))),
				atoi(gtk_entry_get_text(GTK_ENTRY(entryRound)))
				);
		case GTK_RESPONSE_NONE :
		case GTK_RESPONSE_CANCEL :
		default :
			break;
	}
	gtk_widget_destroy(window);
}

int findNumTable(int numApp)
{
	int ret=0,i;
	for (i=0;i<g_nbTable[g_round];i++)
	{
		if ((g_listTable[g_round-1][i].white.numPairing==numApp) ||
		    (g_listTable[g_round-1][i].black.numPairing==numApp))
			ret=i;
	}
	return (ret);
}
void saisieResultatPartie(int numPlayer)
{
	GtkWidget *dialog;
	GtkWidget *saisieResult;
	GtkWidget *labelPlayer;
	GtkWidget *labelAdv;
	GtkWidget *HBox;
	struct player player1,player2;
	char value[8];
	GList *listChildren;
	GList *items;
	
	player1=g_listPlayer.Player[Pairing2Order(numPlayer)];
	if (player1.numAdvTheorique[g_round]==0)
	{
		dialog=gtk_message_dialog_new(
				GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_MESSAGE_ERROR,
		GTK_BUTTONS_OK,
		"Vous ne pouvez pas changer le score de l'exempté.",
		NULL);
		gtk_dialog_run(GTK_DIALOG(dialog));
		gtk_widget_destroy(dialog);
		return;
	}
	dialog=gtk_dialog_new_with_buttons("saisie résultat",
                        GTK_WINDOW(pwindow),
                        GTK_DIALOG_MODAL,
                        GTK_STOCK_OK, GTK_RESPONSE_OK,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			NULL);
	HBox=gtk_hbox_new(TRUE, 0);
	
	items=NULL;
	items=g_list_append(items, "1-0");
	items=g_list_append(items, "0.5-0.5");
	items=g_list_append(items, "0-1");
	items=g_list_append(items, "1-F");
	items=g_list_append(items, "F-1");
	items=g_list_append(items, "F-F");
	items=g_list_append(items, "0-0");
	
	listChildren=gtk_container_children(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox));
	saisieResult=(GtkWidget*)g_list_nth_data (listChildren, 0);

	saisieResult=gtk_combo_new();
	gtk_combo_set_popdown_strings(GTK_COMBO(saisieResult), items);
	
	player2=g_listPlayer.Player[Pairing2Order(player1.numAdvTheorique[g_round])];
	if (player1.color[g_round]==BLACK)
	{
		struct player player0;
		player0=player1;
		player1=player2;
		player2=player0;
	}
	labelPlayer=gtk_label_new(player1.surname);
	labelAdv=gtk_label_new(player2.surname);
	gtk_box_pack_start(GTK_BOX(HBox), labelPlayer, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(HBox), saisieResult, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(HBox), labelAdv, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), HBox,
			   TRUE, FALSE, 0);

	gtk_widget_show(labelPlayer);
	gtk_widget_show(labelAdv);
	gtk_widget_show(saisieResult);
	gtk_widget_show_all(dialog);

        switch(gtk_dialog_run(GTK_DIALOG(dialog)))
        {
		case GTK_RESPONSE_OK :
			strcpy(value, gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(saisieResult)->entry)));
			int numTable=findNumTable(player1.numPairing);
			char c_numTable[4];
			sprintf(c_numTable,"%d",numTable);
			GtkTreePath *path;
			GtkTreeIter iter;
			path=gtk_tree_path_new_from_string(c_numTable);
			gtk_tree_model_get_iter(GTK_TREE_MODEL(listTable), &iter, path);
			gtk_list_store_set(listTable, &iter, RESULT_COLUMN, value, -1);
			strcpy(g_listTable[g_round-1][numTable].result, value);
			gtk_tree_path_free(path);
			getResult(numPlayer, value);
			matchGet[numTable]=TRUE;
			break;
		case GTK_RESPONSE_CANCEL :
		case GTK_RESPONSE_NONE:
		default :
			strcpy(value,"cancel");
			break;
	}
	gtk_widget_destroy(dialog);
}

void fileGrille(GtkWidget *widget, GtkFileSelection *fs)
{
	grilleAmericaine(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)));
	gtk_widget_destroy((GtkWidget*)fs);
	insertPlayerInList();
}

void setGrille(GtkWidget *widget, gpointer data)
{
	GtkWidget *window;
	window=gtk_file_selection_new("Enregistre grille");
	g_signal_connect(G_OBJECT(GTK_FILE_SELECTION(window)->ok_button),
			"clicked", G_CALLBACK(fileGrille), window);
	gtk_signal_connect_object (GTK_OBJECT(GTK_FILE_SELECTION(window)
				     ->cancel_button), "clicked",
				   G_CALLBACK(gtk_widget_destroy),
				   G_OBJECT (window));
	gtk_widget_show(window);
}

void saisieResultat(GtkWidget *widget, gpointer data)
{
	GtkWidget *boite;
	GtkWidget *HBox;
	GtkWidget *entry;
	GtkWidget *labelNum;
		
	boite=gtk_dialog_new_with_buttons("saisie résultat",
			GTK_WINDOW(pwindow),
			GTK_DIALOG_MODAL,
			GTK_STOCK_OK, GTK_RESPONSE_OK,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			NULL);
	g_signal_connect(G_OBJECT(boite), "destroy",
			G_CALLBACK (gtk_widget_destroy), NULL);
	HBox=gtk_hbox_new(TRUE, 0);
	gtk_container_add(GTK_CONTAINER(boite),  HBox);
	
	labelNum=gtk_label_new("n appariement");
	
	entry=gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(HBox), labelNum, TRUE, FALSE, 0);

	gtk_box_pack_start(GTK_BOX(HBox), entry, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(boite)->vbox), HBox,
				TRUE, FALSE, 0);	
	gtk_widget_show(labelNum);
	gtk_widget_show(entry);
	gtk_widget_show(HBox);
	gtk_widget_show_all(GTK_DIALOG(boite)->vbox);
        switch(gtk_dialog_run(GTK_DIALOG(boite)))
        {
                case GTK_RESPONSE_OK :
			saisieResultatPartie(atoi(gtk_entry_get_text(
						GTK_ENTRY(entry))));
			break;
		case GTK_RESPONSE_CANCEL :
		case GTK_RESPONSE_NONE:
		default :
			break;
	}
	gtk_widget_destroy(boite);
}

void afficherResultat(GtkWidget *widget, gpointer data)
{
	g_print ("afficherResultat appelle\n");
}
int addMenu(const gchar* nomMenu, 
	       GtkWidget *root_menu, GtkWidget *menu,
	       void (*f)(GtkWidget *widget, gpointer data))
{
	char buf[128];
	GtkWidget *menu_items;
	sprintf(buf, nomMenu);
	/* creation d'un nouveau item de menu */
	menu_items = gtk_menu_item_new_with_label (buf);
	/* et ajout de celui-ci dans le menu */
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menu_items);

	g_signal_connect (G_OBJECT(menu_items), "activate",
			G_CALLBACK(f), 
			(gpointer) g_strdup(buf));

	/* affichage du widget */
	gtk_widget_show(menu_items);

	/* on sp�cifie que le menu est le menu du menu racine */
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(root_menu), menu);
	
	return 0;
}
/*int addMenuPicture(const gchar* nomMenu, 
	       GtkWidget *root_menu, GtkWidget *menu,
	       void (*f)(GtkWidget *widget, gpointer data))
{
	char buf[128];
	GtkWidget *menu_items;
	sprintf(buf, nomMenu);
	/* creation d'un nouveau item de menu *
	menu_items = gtk_menu_item_new_with_label (buf);
	/* et ajout de celui-ci dans le menu *
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), menu_items);

	g_signal_connect (G_OBJECT(menu_items), "activate",
			G_CALLBACK(f), 
			(gpointer) g_strdup(buf));

	/* affichage du widget *
	gtk_widget_show(menu_items);

	/* on sp�cifie que le menu est le menu du menu racine *
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(root_menu), menu);
	
	return 0;
}*/
void saisieMatch(GtkTreeView *view, GtkTreeSelection *selection)

{
	GtkTreeIter iter;
	GtkTreeViewColumn *focus_column;
	GdkEvent *event;
	event = gtk_get_current_event ();
	if (event!=NULL)
	{
		if (event->button.button==2)
		{
			int numPairing, numAdv, numTable;
			gtk_tree_selection_get_selected (selection, &modelTable,
                                             &iter);
			gtk_tree_model_get(modelTable, &iter,
					   NUM_APP_PLAYER_COLUMN,
					   &numPairing,
					   NUM_TABLE_COLUMN,
					   &numTable,
					   -1);
					   
			saisieResultatPartie(numPairing);
		}
/*		else if (event->type == GDK_2BUTTON_PRESS && event->button == 1)
		{
			printf("button 1\n");
		}*/
	}
}
void defineLog(GtkWidget *widget, gpointer data)
{
	GtkWidget *window, *entryLevelLog, *labelLevelLog, *entryPathLog, *labelPathLog;
	int levelLog;
	char log[2];
	
	window=gtk_dialog_new_with_buttons("Configuration des logs",
		GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_STOCK_OK,GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);
	labelLevelLog=gtk_label_new("Niveau de log");
	labelPathLog =gtk_label_new("fichier de log");
	entryLevelLog=gtk_entry_new();
	sprintf(log, "%d",logLevelView);
	gtk_entry_set_text(GTK_ENTRY(entryLevelLog), log);
	entryPathLog=gtk_entry_new();
	gtk_entry_set_text(GTK_ENTRY(entryPathLog),"/tmp/pass.log");

	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelLevelLog, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryLevelLog, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelPathLog, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryPathLog, TRUE, FALSE, 0);
	gtk_widget_show_all(window);
        switch(gtk_dialog_run(GTK_DIALOG(window)))
	{
		case GTK_RESPONSE_OK :
			levelLog = atoi(gtk_entry_get_text(GTK_ENTRY(entryLevelLog)));
			/*STD_LOG("defineLog")("levelLog=%s, file=%s", gtk_entry_get_text(GTK_ENTRY(labelLevelLog)),  gtk_entry_get_text(GTK_ENTRY(labelPathLog)));*/
			initlog(levelLog, gtk_entry_get_text(GTK_ENTRY(entryPathLog)));
		case GTK_RESPONSE_NONE :
		case GTK_RESPONSE_CANCEL :
		default :
			break;
	}
	gtk_widget_destroy(window);
}

void defineColor(GtkWidget *widget, gpointer data)
{
	GtkWidget *window, *entryColor, *labelColor, *dialog;
	int levelLog;
	char value[8];
	GtkTreeIter iter;
	GtkCellRenderer   * p_cell  = NULL;
	GtkListStore      *p_model  = NULL;
	
	p_model = gtk_list_store_new (1/*2, G_TYPE_INT*/, G_TYPE_STRING);

	dialog=gtk_dialog_new_with_buttons("saisie résultat",
                        GTK_WINDOW(pwindow),
                        GTK_DIALOG_MODAL,
                        GTK_STOCK_OK, GTK_RESPONSE_OK,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			NULL);

	window=gtk_dialog_new_with_buttons("Configuration la couleur du joueur 1",
		GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_STOCK_OK,GTK_RESPONSE_OK,
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
		NULL);
	labelColor=gtk_label_new("Couleur du joueur 1 ronde 1");

	entryColor= gtk_combo_box_new_with_model (GTK_TREE_MODEL (p_model));

	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), labelColor, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(window)->vbox), entryColor, TRUE, FALSE, 0);

	p_cell = gtk_cell_renderer_text_new ();
	gtk_cell_layout_pack_start (GTK_CELL_LAYOUT (entryColor), p_cell, FALSE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT (entryColor), p_cell, "text", 0, NULL);

	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, "BLANC", -1);
	
	gtk_list_store_append (p_model, &iter);
	gtk_list_store_set (p_model, &iter, 0, "NOIR", -1);
	
	if (g_colorNum1==WHITE)
		gtk_combo_box_set_active (GTK_COMBO_BOX (entryColor), 0);
	else
		gtk_combo_box_set_active (GTK_COMBO_BOX (entryColor), 1);
	
	gtk_widget_show_all(window);
        switch(gtk_dialog_run(GTK_DIALOG(window)))
	{
		case GTK_RESPONSE_OK :
			strcpy(value, gtk_combo_box_get_active_text(GTK_COMBO_BOX(entryColor)));
			if (!strcmp(value, "BLANC"))
				g_colorNum1=WHITE;
			else g_colorNum1=BLACK;

		case GTK_RESPONSE_NONE :
		case GTK_RESPONSE_CANCEL :
		default :
			break;
	}
	gtk_widget_destroy(window);
}

void apropos(GtkWidget *widget, gpointer data)
{
	GtkWidget *dialog;
	dialog=gtk_message_dialog_new(
		GTK_WINDOW(pwindow),
		GTK_DIALOG_MODAL,
		GTK_MESSAGE_INFO,
		GTK_BUTTONS_OK,
		VERSION,
		NULL);
	gtk_dialog_run(GTK_DIALOG(dialog));
	gtk_widget_destroy(dialog);
}

void defineTreeTable()
{
	GtkTreeViewColumn *column;
	GtkTreeSelection *selection;
	GtkCellRenderer *renderer;
	GtkTreeIter iterTable;
	
	modelTable=GTK_TREE_MODEL(listTable);
	listTable=gtk_list_store_new(N_TABLE_COLUMNS, G_TYPE_INT,
			G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT,
			G_TYPE_STRING);
	gtk_list_store_append(listTable, &iterTable);
	
	viewPairing=gtk_tree_view_new_with_model(GTK_TREE_MODEL (listTable));

	g_object_unref (G_OBJECT(listTable));
	renderer= gtk_cell_renderer_text_new();
	
	column = gtk_tree_view_column_new_with_attributes ("Table",
					renderer, "text", NUM_TABLE_COLUMN,
					NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPairing), column);

	column = gtk_tree_view_column_new_with_attributes ("num app",
					renderer, "text", NUM_APP_PLAYER_COLUMN,
					NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPairing), column);
	
	column = gtk_tree_view_column_new_with_attributes ("Player",
					renderer, "text", PLAYER_COLUMN, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPairing), column);
	
	column=gtk_tree_view_column_new_with_attributes("Result",
					renderer, "text", RESULT_COLUMN, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPairing), column);

	column = gtk_tree_view_column_new_with_attributes ("num app",
					renderer, "text", NUM_APP_ADV_COLUMN,
					NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPairing), column);
	
	column=gtk_tree_view_column_new_with_attributes ("Adversaire",
					renderer, "text", ADV_COLUMN, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPairing), column);
	
	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(viewPairing));
	g_signal_connect(viewPairing, "cursor-changed", 
			G_CALLBACK(saisieMatch),selection);
}
void defineTreePlayer()
{
	GtkTreeViewColumn *column;
	GtkTreeSelection *selection;
	GtkCellRenderer *renderer;
	GtkTreeIter iterPlayer;
	/* TreeList*/
	modelPlayer=GTK_TREE_MODEL(listPlayer);
	listPlayer=gtk_list_store_new(N_PLAYER_COLUMNS, 
			G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INT,
			G_TYPE_DOUBLE);
	gtk_list_store_append(listPlayer, &iterPlayer);
	
	viewPlayer=gtk_tree_view_new_with_model(GTK_TREE_MODEL (listPlayer));

	g_object_unref (G_OBJECT(listPlayer));
	renderer= gtk_cell_renderer_text_new();
	
	column = gtk_tree_view_column_new_with_attributes ("Num App",
					renderer, "text", P_NUM_APP_COLUMN,
					NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPlayer), column);

	column = gtk_tree_view_column_new_with_attributes ("Nom",
					renderer, "text", P_SURNAME_COLUMN,
					NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPlayer), column);
	
	column = gtk_tree_view_column_new_with_attributes ("Prenom",
					renderer, "text", P_NAME_COLUMN, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPlayer), column);

	column=gtk_tree_view_column_new_with_attributes("Elo",
					renderer, "text", P_ELO_COLUMN, NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPlayer), column);

	column = gtk_tree_view_column_new_with_attributes ("Score",
					renderer, "text", P_RESULT_COLUMN,
					NULL);
	gtk_tree_view_append_column(GTK_TREE_VIEW(viewPlayer), column);
	
	selection= gtk_tree_view_get_selection(GTK_TREE_VIEW(viewPlayer));
}
void onDestroy(GtkWidget *pWidget, gpointer pData)
{
	if (newMatch)
	{
		int i;
		free(resultGet);
		free(resultValidate);
		free(roundAlreadyPaired);
		free(matchGet);
		free(g_nbPlayerOut);
		free(g_nbTable);
		for (i=0;i<nbRoundPaired; i++)
			free(g_listTable[i]);
		free(g_listTable);
	}
	gtk_main_quit();
}
void defineTreeList()
{
	defineTreeTable();
	defineTreePlayer();
}

void onQuit(GtkWidget* widget, gpointer data)
{
	GtkWidget *pQuestion;
        pQuestion = gtk_message_dialog_new(GTK_WINDOW(data),
		        GTK_DIALOG_MODAL,
		        GTK_MESSAGE_QUESTION,
		        GTK_BUTTONS_YES_NO,
		        "Voulez vous vraiment\n"
		        "quitter le programme?");
	switch(gtk_dialog_run(GTK_DIALOG(pQuestion)))
	{
		case GTK_RESPONSE_YES:
			if (newMatch)
			{
				int i;
				free(resultGet);
				free(resultValidate);
				free(roundAlreadyPaired);
				free(matchGet);
				free(g_nbPlayerOut);
				free(g_nbTable);
				for (i=0;i<nbRoundPaired; i++)
					free(g_listTable[i]);
				free(g_listTable);
			}
			gtk_main_quit();
			break;
		case GTK_RESPONSE_NONE:
		case GTK_RESPONSE_NO:
			gtk_widget_destroy(pQuestion);
			break;
	}
}

int main(int argc, char *argv[])
{
	GtkWidget *menu_file, *menu_appariement, *menu_player;
	GtkWidget *menu_result, *menu_affichage, *menu_configure;
	GtkWidget *menu_bar, *menu_help;
	GtkWidget *root_menu_file, *root_menu_appariement, *root_menu_result;
	GtkWidget *root_menu_player, *root_menu_affichage, *root_menu_configure;
	GtkWidget *root_menu_help;
	GtkWidget *vbox;
	GtkWidget *labelRound, *entryNbRound;
	GtkWidget *pMenuItem;
	char buf[128];
	int i;

	initlog(1, "/tmp/pass.log");
	gtk_init(&argc, &argv);
	newMatch=FALSE;
	nbRoundPaired=0;
	g_colorNum1=BLACK;
	initExempt();
	
	/* creation nouvelle fenetre */
	pwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW (pwindow), "P.A.S.S.");
	g_signal_connect(G_OBJECT (pwindow), "delete_event", G_CALLBACK(onDestroy), NULL);

	/*initialise le widget menu */
	menu_file = gtk_menu_new();
	menu_appariement = gtk_menu_new();
	menu_player = gtk_menu_new();
	menu_result = gtk_menu_new();
	menu_affichage = gtk_menu_new();
	menu_configure = gtk_menu_new();
	menu_help = gtk_menu_new();

	root_menu_file = gtk_menu_item_new_with_label("Fichier");
	root_menu_appariement = gtk_menu_item_new_with_label("Appariement");
	root_menu_player = gtk_menu_item_new_with_label("Joueur");
	root_menu_result = gtk_menu_item_new_with_label("Résultat");
	root_menu_affichage = gtk_menu_item_new_with_label("Affichage");
	root_menu_configure = gtk_menu_item_new_with_label("Configure");
	root_menu_help = gtk_menu_item_new_with_label("Aide");
	
	gtk_widget_show(root_menu_file);
	gtk_widget_show(root_menu_appariement);
	gtk_widget_show(root_menu_player);
	gtk_widget_show(root_menu_result);
	gtk_widget_show(root_menu_affichage);
	gtk_widget_show(root_menu_configure);
	gtk_widget_show(root_menu_help);

	/* MENU FICHIER */
	pMenuItem=gtk_image_menu_item_new_from_stock(GTK_STOCK_NEW, NULL);
	gtk_label_set_label(GTK_LABEL(GTK_BIN(pMenuItem)->child), "Nouveau Tournoi");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	g_signal_connect(G_OBJECT(pMenuItem), "activate",
			G_CALLBACK(newTournament), NULL);
	gtk_widget_show(pMenuItem);
	
	pMenuItem=gtk_image_menu_item_new_from_stock(GTK_STOCK_SAVE, NULL);
	gtk_label_set_label(GTK_LABEL(GTK_BIN(pMenuItem)->child), "Enregistrer Tournoi");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	g_signal_connect(G_OBJECT(pMenuItem), "activate",
			G_CALLBACK(saveTournament), NULL);
	gtk_widget_show(pMenuItem);
	
	pMenuItem=gtk_image_menu_item_new_from_stock(GTK_STOCK_OPEN, NULL);
	gtk_label_set_label(GTK_LABEL(GTK_BIN(pMenuItem)->child), "Ouvrir Tournoi");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	g_signal_connect(G_OBJECT(pMenuItem), "activate",
			G_CALLBACK(readTournament), NULL);
	gtk_widget_show(pMenuItem);
	
	pMenuItem=gtk_separator_menu_item_new();
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	gtk_widget_show(pMenuItem);
/*	
	pMenuItem=gtk_image_menu_item_new_from_stock(GTK_STOCK_SAVE, NULL);
	gtk_label_set_label(GTK_LABEL(GTK_BIN(pMenuItem)->child), "Enregistrer liste joueur");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	g_signal_connect(G_OBJECT(pMenuItem), "activate",
			G_CALLBACK(saveFile), NULL);
	gtk_widget_show(pMenuItem);*/
	
	pMenuItem=gtk_image_menu_item_new_from_stock(GTK_STOCK_OPEN, NULL);
	gtk_label_set_label(GTK_LABEL(GTK_BIN(pMenuItem)->child), "Ouvrir liste joueur");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	g_signal_connect(G_OBJECT(pMenuItem), "activate",
			G_CALLBACK(openFilePlayer), NULL);
	gtk_widget_show(pMenuItem);
	
	pMenuItem=gtk_separator_menu_item_new();
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	gtk_widget_show(pMenuItem);
	
	pMenuItem=gtk_image_menu_item_new_from_stock(GTK_STOCK_CLOSE, NULL);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_file), pMenuItem);
	g_signal_connect(G_OBJECT(pMenuItem), "activate",
			G_CALLBACK(onQuit), NULL);
	gtk_widget_show(pMenuItem);
	
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(root_menu_file), menu_file);
	/* MENU APPARIEMENT */
	addMenu("Calcul appariement", root_menu_appariement, menu_appariement, calculPairing);

	/* MENU JOUEUR */
	addMenu("Ajout joueur", root_menu_player, menu_player, addPlayer);
	addMenu("Sortir joueur", root_menu_player, menu_player, supPlayer);
	addMenu("forfait", root_menu_player, menu_player, forfaitPlayer);

	/* Menu Resultat */
	addMenu("Saisie résultat", root_menu_result, menu_result, saisieResultat);
	addMenu("grille américaine", root_menu_result, menu_result, setGrille);
	
	/* MENU AFFICHAGE */
	GSList *pList;
	pList=NULL;
	pMenuItem=gtk_radio_menu_item_new_with_label(NULL, "Appariement");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_affichage), pMenuItem);
	pList = gtk_radio_menu_item_get_group(GTK_RADIO_MENU_ITEM(pMenuItem));
	g_signal_connect(G_OBJECT(pMenuItem), "activate", G_CALLBACK(affichagePairing), NULL);
	gtk_widget_show(pMenuItem);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(root_menu_affichage), menu_affichage);

	pMenuItem=gtk_radio_menu_item_new_with_label(pList, "Joueur");
	gtk_menu_shell_append(GTK_MENU_SHELL(menu_affichage), pMenuItem);
	pList = gtk_radio_menu_item_get_group(GTK_RADIO_MENU_ITEM(pMenuItem));
	g_signal_connect(G_OBJECT(pMenuItem), "activate", G_CALLBACK(affichagePlayer), NULL);
	gtk_widget_show(pMenuItem);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(root_menu_affichage), menu_affichage);

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(pwindow), vbox);
	gtk_widget_show(vbox);

	/* Menu Configure */
	addMenu("Log", root_menu_configure, menu_configure, defineLog);
	addMenu("Couleur", root_menu_configure, menu_configure, defineColor);
	
	/* Menu Aide */
	addMenu("A propos de pass", root_menu_help, menu_help, apropos);
	
	/* creation d'une barre de menus */
	menu_bar = gtk_menu_bar_new();
	gtk_box_pack_start(GTK_BOX(vbox), menu_bar, FALSE, FALSE, 2);

	/* ajout de menu a la barre de menu */
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_file);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_appariement);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_player);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_result);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_affichage);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_configure);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), root_menu_help);

	defineTreeList();
	
	gtk_box_pack_start(GTK_BOX(vbox), viewPairing, TRUE, FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), viewPlayer, TRUE, FALSE, 0);
	
	gtk_widget_show(menu_bar);
	gtk_widget_show(viewPairing);
	gtk_widget_show(pwindow);
	gtk_main();
	return OK;
}
