/*
	Copyright 2003 Xavier Dunat

    This file is part of Suisse.

    Suisse is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Suisse is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Suisse; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <string.h>
#include "joueur.h"
#include "ruleA.h"

/**
 *\file ruleA.c
 *\author Xavier Dunat
 *\brief Régles A
 */

/****************************************/
/*       fonction triPlayerLevel        */
/*                                      */
/* entree : list de player              */
/*          niveau du tri		*/
/*          min et max                  */
/****************************************/
int triPlayerLevel(struct player *list, int level, int min, int max)
{
	int compt1, compt2, index;
	switch (level)
	{
	case 0 :
		{
	/* TRI NIVEAU 0 : score */
			for (compt1=min; compt1 < max; compt1++)
				for (compt2=compt1+1; compt2 <= max; compt2++)
				{
					if (list[compt1].score < list[compt2].score)
						inversePlayer(list, compt1, compt2);
				}
			for (compt1=min; compt1 < max; compt1++)
			{
				index=0;
				while (
				(list[compt1].score==list[compt1+index+1].score)
				&& (compt1+index+1<=max))
					index++;
				if (index>0)
					triPlayerLevel(list, 1, compt1, compt1+index);
			}
			break;
		}
	case 1 :
		{
	/* TRI NIVEAU 1 : elo */
			for (compt1=min; compt1 < max; compt1++)
				for (compt2=compt1+1; compt2 <= max; compt2++)
					if (list[compt1].elo < list[compt2].elo)
					    inversePlayer(list, compt1, compt2);
			for (compt1=min; compt1 < max; compt1++)
			{
				index=0;
				while ((list[compt1].elo==list[compt1+index+1].elo) && (compt1+index+1<=max))
					index++;
				if (index>0)
					triPlayerLevel(list, 2, compt1, compt1+index);
			}
			break;
		}
	case 2 :
		{
	/* TRI NIVEAU 2 : title */
			for (compt1=min; compt1 < max; compt1++)
				for (compt2=compt1+1; compt2 <= max; compt2++)
					if (list[compt1].title < list[compt2].title)
						inversePlayer(list, compt1, compt2);
			for (compt1=min; compt1 < max; compt1++)
			{
				index=0;
				while ((list[compt1].title==list[compt1+index+1].title) && (compt1+index+1<=max))
					index++;
				if (index>0)
					triPlayerLevel(list, 3, compt1, compt1+index);
			}
			break;
		}
	case 3 :
		{
	/* TRI NIVEAU 3 : name */
			for (compt1=min; compt1 < max; compt1++)
				for (compt2=compt1+1; compt2 <= max; compt2++)
					if (strcmp(list[compt1].surname, list[compt2].surname)>0)
						inversePlayer(list, compt1, compt2);
			break;
		}
	default : return (1);
	}
	return (OK);
}

/******************************************/
/*         fonction triPlayer             */
/*                                        */
/* entree : list de joueur               */
/*          nombre de joueur dans la list*/
/* retour : OK                            */
/******************************************/
int triPlayer(struct player *list, int number)
{
	triPlayerLevel(list, 0, 0, number-1);
	return (OK);
}
